<?php

//Überprüfung on die SESSION noch gültig ist
@session_start();
if (!isset($_SESSION['beroari_time'])) {
    echo "<script>window.location='../index.php?m=sip'</script>";
} elseif ((isset($_SESSION['beroari_time'])) && (($_SESSION['beroari_time'] + 1200) < time())) {
    @session_unset();
    @session_destroy();
    echo "<script>window.location='../index.php?m=sip'</script>";
} else {
    $_SESSION['beroari_time'] = time();

    chdir("..");

    include "./includes/variables.php";
    include "./includes/Helper.php";
    include "./misc/database.php";
    require_once "./includes/isgwtelnet.php";
    $ba = new beroAri();
    require_once("./includes/lang.php");

    function parameters($config = "") {
        foreach ($_POST as $key => $value) {
            $_POST[$key] = str_replace("'", "\"", $_POST[$key]);
        }

        //T.38
        if (isset($_POST['t38']) && $config != "") {
            $config.=",t38=1";
        } elseif (isset($_POST['t38']) && $config == "") {
            $config.="t38=1";
        } elseif (!isset($_POST['t38']) && $config != "") {
            $config.=",t38=0";
        } elseif (!isset($_POST['t38']) && $config == "") {
            $config.="t38=0";
        }



        //IE on SIP
        if (isset($_POST['ie_on_sip'])) {
            $config.=",ie_on_sip=1";
        } elseif (!isset($_POST['ie_on_sip'])) {
            $config.=",ie_on_sip=0";
        }


        //WAIT FOR CANCEL
        if (isset($_POST['wait_for_cancel'])) {
            $config.=",wait_for_cancel=1";
        } elseif (!isset($_POST['wait_for_cancel'])) {
            $config.=",wait_for_cancel=0";
        }


        //DTMF
        if (isset($_POST['dtmfmode']))
            $config.=",dtmfmode=" . $_POST['dtmfmode'];

        //S2I CPT
        if (isset($_POST['s2i_cpt']))
            $config.=",s2i_cpt=" . $_POST['s2i_cpt'];
        //I2S CPT
        if (isset($_POST['i2s_cpt']))
            $config.=",i2s_cpt=" . $_POST['i2s_cpt'];

        //FAILOVER_PROXY
        if (isset($_POST['failover_proxy']))
            $config.=",failover_proxy=" . $_POST['failover_proxy'];

        //FAILOVER_PROXY
        if (isset($_POST['failover_timeout']))
            $config.=",failover_timeout=" . $_POST['failover_timeout'];
        
        //SIP_NATIONAL_CODE
        if (isset($_POST['sip_national_code']))
            $config.=",sip_national_code=" . $_POST['sip_national_code'];
        
        //SIP_INTERNATIONAL_CODE
        if (isset($_POST['sip_international_code']))
            $config.=",sip_international_code=" . $_POST['sip_international_code'];
        
        //ISDN2SIP_DESTINATION_NUMFORMAT
        if (isset($_POST['isdn2sip_destination_numformat']))
            $config.=",isdn2sip_destination_numformat=" . $_POST['isdn2sip_destination_numformat'];
        
        //DIALPLAN_INTERNATIONAL_PREFIX
        if (isset($_POST['dialplan_international_prefix']))
            $config.=",dialplan_international_prefix=" . $_POST['dialplan_international_prefix'];
        
        //SIP2DIALPLAN_DAD_PREFIX_SETTING
        if (isset($_POST['sip2dialplan_dad_prefix_setting']))
            $config.=",sip2dialplan_dad_prefix_setting=" . $_POST['sip2dialplan_dad_prefix_setting'];
        
        //SIP2DIALPLAN_OAD_PREFIX_SETTING
        if (isset($_POST['sip2dialplan_oad_prefix_setting']))
            $config.=",sip2dialplan_oad_prefix_setting=" . $_POST['sip2dialplan_oad_prefix_setting'];
        
        //DIALPLAN2SIP_OAD_PREFIX_SETTING
        if (isset($_POST['dialplan2sip_oad_prefix_setting']))
            $config.=",dialplan2sip_oad_prefix_setting=" . $_POST['dialplan2sip_oad_prefix_setting'];
        
        //SRTP_MODE
        if (isset($_POST['srtp_mode']))
            $config.=",srtp_mode=" . $_POST['srtp_mode'];

        //SRTP_CRYPTO_SUITES
        $c = "";
        for ($i = 0; $i < count($_POST['srtp_crypto_suites']); $i++) {
            if ($c != "")
                $c.=":";
            $c.= $_POST['srtp_crypto_suites'][$i];
        }
        if ($c != "")
            $config.=",srtp_crypto_suites=" . $c;
        
        //SIP_SRC_SETTING
        if (isset($_POST['from_sip_src_setting']))
            $config.=",from_sip_src_setting=" . $_POST['from_sip_src_setting'];

        //SIP_TO_USER_SETTING
        if (isset($_POST['sip_to_user_setting']) && $_POST['sip_to_user_setting'] != 'manual')
            $config.=",sip_to_user_setting=" . $_POST['sip_to_user_setting'];
        else if (isset($_POST['sip_to_user_setting']) && $_POST['sip_to_user_setting'] == 'manual')
            $config.=",sip_to_user_setting=" . $_POST['sip_to_user_setting_manual'];
        
        //SIP_FROM_USER_SETTING
        if (isset($_POST['sip_from_user_setting']) && $_POST['sip_from_user_setting'] != 'manual')
            $config.=",sip_from_user_setting=" . $_POST['sip_from_user_setting'];
        else if (isset($_POST['sip_from_user_setting']) && $_POST['sip_from_user_setting'] == 'manual')
            $config.=",sip_from_user_setting=" . $_POST['sip_from_user_setting_manual'];

        //SIP_FROM_DISPLAY_SETTING
        if (isset($_POST['sip_from_display_setting']) && $_POST['sip_from_display_setting'] != 'manual')
            $config.=",sip_from_display_setting=" . $_POST['sip_from_display_setting'];
        else if (isset($_POST['sip_from_display_setting']) && $_POST['sip_from_display_setting'] == 'manual')
            $config.=",sip_from_display_setting=" . $_POST['sip_from_display_setting_manual'];

        //CODECS
        $c = "";
        for ($i = 0; $i < count($_POST['codecs']); $i++) {
            if ($c != "")
                $c.=":";
            $c.= $_POST['codecs'][$i];
        }
        if ($c != "")
            $config.=",codecs=" . $c;
        
        
        //Additional config string hinzufügen.
        if ($_POST['addit_options'] != "")
            $config.="," . str_replace(array("\r\n", "\n", "\r"), ",", $_POST['addit_options']);

        return $config;
    }

    $name = $_POST['name'];
    $ser_addr = $_POST['server_address'];
    $user = sqlite_escape_string($_POST['user']);
    $auth_user = sqlite_escape_string($_POST['auth_user']);
    $displayname = sqlite_escape_string($_POST['displayname']);
    if (is_array($_POST['matchtype'])) {
        foreach ($_POST['matchtype'] as $type) {
            $matchtype .=($matchtype == "") ? "" : "|";
            $matchtype.=$type;
        }
        if (in_array('manual', $_POST['matchtype']))
                $matchtype_manual=$_POST['matchtype_manual'];
    }
    $profile = sqlite_escape_string($_POST['profile']);
    $secret = sqlite_escape_string($_POST['secret']);
    $sip_transport = $_POST['sip_transport'];
    $register = $_POST['register'];
    $enum_support = $_POST['enum_support'];
    $enum_search_domains = $_POST['enum_search_domains'];
    if ($_POST['option'] == "stun")
        $stunserver = $_POST['stunserver'];
    if ($register == 1) {
        $regrefresh = $_POST['regrefresh'];
        $register_option = $_POST['register_option'];
        $keepalive_interval = $_POST['keepalive_interval'];
    } else {
        $regrefresh = "";
        $register_option = "no-validate no-options-keepalive";
        $keepalive_interval = "30";
    }
    if ($_POST['option'] == "externip")
        $externip = $_POST['externip'];
    if ($_POST['option'] == "nonat") {
        $externip = "";
        $stunserver = "";
    }
    $config = parameters();
    $id = $_POST['id_upd'];
    //After modify
    if ($_POST['id_upd']) {
        $query_new = $ba->update('UPDATE sip SET name=\'' . sqlite_escape_string($name) . '\', sip_transport=\'' . sqlite_escape_string($sip_transport) . '\', server_address=\'' . sqlite_escape_string($ser_addr) . '\', '
                . 'user=\'' . sqlite_escape_string($user) . '\', auth_user=\'' . sqlite_escape_string($auth_user) . '\', displayname=\'' . sqlite_escape_string($displayname) . '\', secret=\'' . sqlite_escape_string($secret) . '\', '
                . 'register=\'' . sqlite_escape_string($register) . '\', regrefresh=\'' . sqlite_escape_string($regrefresh) . '\', register_option=\'' . sqlite_escape_string($register_option) . '\', config=\'' . sqlite_escape_string($config) . '\', '
                . 'stunserver=\'' . sqlite_escape_string($stunserver) . '\', externip=\'' . sqlite_escape_string($externip) . '\',  profile=\'' . sqlite_escape_string($profile) . '\', '
                . 'matchtype=\'' . sqlite_escape_string($matchtype) . '\', matchtype_manual=\'' . sqlite_escape_string($matchtype_manual) . '\', enum_support=\'' . sqlite_escape_string($enum_support) . '\', '
                . 'enum_search_domain=\'' . sqlite_escape_string($enum_search_domains) . '\', keepalive_interval=\'' . sqlite_escape_string($keepalive_interval) . '\' WHERE id=\'' . $id . '\'');
        //Add new SIP account
    } else {
        $query_new = $ba->insert_('INSERT INTO sip (name, sip_transport, server_address, user, auth_user, displayname, secret, register,  config,externip,stunserver,regrefresh,register_option,profile,matchtype,matchtype_manual,enum_support,enum_search_domain, keepalive_interval) '
                . 'VALUES (\'' . sqlite_escape_string($name) . '\', \'' . sqlite_escape_string($sip_transport) . '\', \'' . sqlite_escape_string($ser_addr) . '\', \'' . sqlite_escape_string($user) . '\', '
                . '\'' . sqlite_escape_string($auth_user) . '\', \'' . sqlite_escape_string($displayname) . '\', \'' . sqlite_escape_string($secret) . '\', \'' . sqlite_escape_string($register) . '\','
                . '\'' . sqlite_escape_string($config) . '\',\'' . sqlite_escape_string($externip) . '\',\'' . sqlite_escape_string($stunserver) . '\',\'' . sqlite_escape_string($regrefresh) . '\','
                . '\'' . sqlite_escape_string($register_option) . '\',\'' . sqlite_escape_string($profile) . '\',\'' . sqlite_escape_string($matchtype) . '\',\'' . sqlite_escape_string($matchtype_manual) . '\','
                . '\'' . sqlite_escape_string($enum_support) . '\',\'' . sqlite_escape_string($enum_search_domains) . '\', \'' . sqlite_escape_string($keepalive_interval) . '\')');
    }
    if (!$ba->is_error() && $_POST['id_upd']) {
        $query = $ba->update("UPDATE dialplan SET fromId='p:" . sqlite_escape_string($name) . "'
						where fromDirection='sip' and fromId='p:" . sqlite_escape_string($_POST['alt_name']) . "'");
        $query = $ba->update("UPDATE dialplan SET toId='p:" . sqlite_escape_string($name) . "'
						where toDirection='sip' and toId='p:" . sqlite_escape_string($_POST['alt_name']) . "'");
        $query = $ba->update("UPDATE dialplan SET fromId='d:" . sqlite_escape_string($name) . "'
						where fromDirection='sip' and fromId='d:" . sqlite_escape_string($_POST['alt_name']) . "'");
    }
    Helper::activate(1);
    if (!$ba->is_error()) {
        echo "<script>window.location='../index.php?m=sip'</script>";
    } else {
        echo "<script>alert('" . $ba->error() . "');</script>";
    }
}
?>
